// -------------------------------------------------------------------------------
// 
// 		cwCu		TEhvOwb_t@C
// 
// 				Ver 3.21 
// 
// -------------------------------------------------------------------------------

#ifndef DX_SOUND_H
#define DX_SOUND_H

#include "DxCompileConfig.h"

#ifndef DX_NON_SOUND

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxRingBuffer.h"
#include "DxSoundConvert.h"
#include "DxHandle.h"
#include "DxFile.h"

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxSoundWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
#include "Android/DxSoundAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxSoundiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define MAX_SOUNDBUFFER_NUM				(10)			// DIRECTSOUNDBUFFER obt@̍ő吔
#define STS_SETSOUNDNUM					(4)				// Xg[TEhĐɓo^łTEh̐

#define SOUNDBUFFER_MAX_CHANNEL_NUM		(8)				// ΉTEh`l̍ő吔

#define SOUND_SINTABLE_DIV				(65536)			// TCe[u̐x

#define SOUND_FFT_BITCOUNT_MIN			(4)				// t[GϊŎgpTv̍ŏrbg
#define SOUND_FFT_BITCOUNT_MAX			(16)			// t[GϊŎgpTv̍őrbg
	
#define SOUND_BEEPSOUNDBUFFER_NUM		(3)				// BEEPĐp̃TEhobt@̐


// TEhnhG[`FbNp}N
#define SOUNDHCHK( HAND, SPOINT )			HANDLECHK(       DX_HANDLETYPE_SOUND, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SOUNDHCHK_ASYNC( HAND, SPOINT )		HANDLECHK_ASYNC( DX_HANDLETYPE_SOUND, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// \tgTEhnhG[`FbNp}N
#define SSND_MASKHCHK( HAND, SPOINT )		HANDLECHK(       DX_HANDLETYPE_SOFTSOUND, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SSND_MASKHCHK_ASYNC( HAND, SPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_SOFTSOUND, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// ~[WbNnhG[`FbNp}N
#define MIDI_MASKHCHK( HAND, SPOINT )		HANDLECHK(       DX_HANDLETYPE_MUSIC, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define MIDI_MASKHCHK_ASYNC( HAND, SPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_MUSIC, HAND, *( ( HANDLEINFO ** )&SPOINT ) )


// \̒` --------------------------------------------------------------------

// t@CTEhnh쐬鏈ɕKvȃO[of[^Z߂
struct LOADSOUND_GPARAM
{
	int							NotInitSoundMemDelete ;					// InitSoundMem ō폜Ȃǂ̃tO( TRUE:InitSoundMemł͍폜Ȃ  FALSE:InitSoundMemō폜 )
	int							Create3DSoundFlag ;						// 3DTEh쐬邩ǂ̃tO( TRUE:RcTEh쐬  FALSE:RcTEh쐬Ȃ )
	int							CreateSoundDataType ;					// 쐬TEhf[^̃f[^^Cv
	int							CreateSoundPitchRateEnable ;			// 쐬TEhf[^̃sb`[gLǂ
	float						CreateSoundPitchRate ;					// 쐬TEhf[^̃sb`[g
	int							CreateSoundTimeStretchRateEnable ;		// 쐬TEhf[^̃^CXgb`[gLǂ
	float						CreateSoundTimeStretchRate ;			// 쐬TEhf[^̃^CXgb`[g
	int							CreateSoundLoopStartTimePosition ;		// 쐬TEhf[^̃[v͈͂̐[( ~b )
	int							CreateSoundLoopStartSamplePosition ;	// 쐬TEhf[^̃[v͈͂̐[( Tv )
	int							CreateSoundLoopEndTimePosition ;		// 쐬TEhf[^̃[v͈͂̏I[( ~b )
	int							CreateSoundLoopEndSamplePosition ;		// 쐬TEhf[^̃[v͈͂̏I[( Tv )
	int							CreateSoundIgnoreLoopAreaInfo ;			// 쐬TEhf[^Ń[v͈͏𖳎邩ǂ
	int							DisableReadSoundFunctionMask ;			// gpȂǂݍݏ̃}XN
#ifndef DX_NON_OGGVORBIS
	int							OggVorbisBitDepth ;						// nugp̃rbg[x(1:8bit 2:16bit)
	int							OggVorbisFromTheoraFile ;				// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif
} ;

// TEhobt@bNۂɎgpf[^^
struct SOUNDBUFFERLOCKDATA
{
	DWORD						StartOffst ;
	BYTE						*WriteP, *WriteP2 ;
	DWORD						Length, Length2 ;
	DWORD						Offset, Offset2 ;
	DWORD						Valid, Valid2 ;
} ;

// g`f[^\
struct WAVEDATA
{
	void						*Buffer ;				// g`f[^
	void						*DoubleSizeBuffer ;		// Q{eʂ̔g`f[^
	int							Bytes ;					// TCY
	int							RefCount ;				// QƐ
} ;

// RcTEhf[^̊{Iȏ
struct _3DSOUNDINFO
{
	VECTOR						Position ;				// ʒu
	VECTOR						FrontDirection ;		// O
	VECTOR						UpDirection ;			// 
	VECTOR						Velocity ;				// ړx
	float						InnerAngle ;			// px
	float						OuterAngle ;			// Opx
	float						InnerVolume ;			// pxł̉ʃXP[
	float						OuterVolume ;			// Opxł̉ʃXP[
} ;

// TEhobt@\
struct SOUNDBUFFER
{
	int							Valid ;					// f[^Lۂ(TRUE:L FALSE:)

	int							Pan ;					// p( 10000:100%E0%  0:E100%  -100000:E100% )
	int							Volume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;	// {[( 10000:0%  0:100% )
	int							Frequency ;				// Đg( -1:ftHg )
	int							SampleNum ;				// Tv̐

	WAVEFORMATEX				Format ;				// obt@̃tH[}bg

	int							UseGetCurrentPosition ;	// GetCurrentPosition gp邩ǂ
	int							IsStream ;				// Xg[Đp̃TEhobt@ǂ

	// DirectSound ȊȌꍇɎgp
	WAVEDATA					*Wave ;					// g`f[^obt@
	volatile int				State ;					// Đ( TRUE:Đ  FALSE:~ )
	volatile int				Pos ;					// Đʒu
	volatile int				CompPos ;				// ]ʒu
	int							Loop ;					// [v邩ǂ( TRUE:[v  FALSE:[vȂ )
	int							CalcPan ;				// Lv`pɌvZ̃p( 256:100%E0%  0:E100%  -256:E100% )
	int							CalcVolume ;			// Lv`pɌvZ̃{[( 256:100%  0:0% )
	volatile int				StopTimeState ;			// StopTime ̏( 0:얳 1:ĐI҂ 2:Ԍoߑ҂ )
	volatile int				StopTime ;				// Đ~

	// RcTEhĐpf[^
	int							Is3DSound ;												// RcTEhǂ
	_3DSOUNDINFO				EmitterInfo ;											// RcTEhp̏
	float						EmitterRadius ;											// RcTEhp̉͂
	float						EmitterInnerRadius ;									// RcTEhp̉ʂPOOŕ鋗
	int							EmitterDataChangeFlag ;									// RcTEhp񂪕ύXꂽǂ( TRUE:ύXꂽ  FALSE:ύXĂȂ )
	float						DSound_Calc3DVolume ;									// DirectSoundp̂RcvZ̃{[
	float						DSound_Calc3DPan ;										// DirectSoundp̂RcvZ̃p

	SOUNDBUFFER_PF				PF ;					// ˑ
} ;

// Xg[TEhvCpt@Cf[^
struct STREAMFILEDATA
{
	signed char					LoopNum ;					// [v( -1:[v )
	int							DataType ;					// f[^̃^Cv( DX_SOUNDDATATYPE_MEMNOPRESS  )
	void						*FileImage ;				// ɓWJt@CC[W( DX_SOUNDDATATYPE_FILE ȊOŎgp )
	int							FileImageSize ;				// ɓWJt@CC[W̃TCY( DX_SOUNDDATATYPE_FILE ȊOŎgp )
	STREAMDATA					MemStream ;					// Xg[pf[^( DX_SOUNDDATATYPE_FILE ȊOŎgp )
	int							LoopSamplePosition ;		// [v̍Đʒu(TvPʁAOGG  kWAV ̂ݗL )
	int							LoopStartSamplePosition ;	// [vJnĐʒu(TvPʁAOGG  kWAV ̂ݗL )
	
	SOUNDCONV					ConvData ;					// tH[}bgϊpf[^
} ;

// Xg[TEhvCpf[^
struct STREAMPLAYDATA
{
	int							BufferBorrowSoundHandle ;								// DirectSoundBuffer ݂ĂTEhnh(-1:؂ĂȂ)
	int							BufferBorrowSoundHandleCount ;							// DirectSoundBuffer ݂Ă鐔(0:݂ĂȂ)
	int							BufferUseSoundHandle ;									// DirectSoundBuffer ݎgpĂTEhnh(-1:N͎gĂȂ)
	int							DeleteWaitFlag ;										// DirectSoundBuffer ݂Ă邩폜łȂŋ̂AtO
	
	BYTE						*SoundBuffer ;											// TEhobt@( XAudio2p )
	DWORD						SoundBufferSize ;										// DirectSoundBuffer ̃TCY( Pʂ̓oCg )
	int							SoundBufferCompCopyOffset ;								// ÕTEhf[^Rs[œ]TEhf[^̖̈[ItZbg
	int							SoundBufferCopyStartOffset ;							// w܂ł玟̃TEhf[^Rs[JnxƂf[^ItZbg

	STREAMFILEDATA				File[ STS_SETSOUNDNUM ] ;								// Xg[t@Cf[^
	BYTE						FileLibraryLoadFlag[ STS_SETSOUNDNUM ] ;				// Cu[hf[^ǂ
	int							FileNum ;												// Xg[t@Cf[^̐
	int							FileActive ;											// ANeBuȃXg[t@Cf[^ԍ
	int							FileLoopCount ;											// ݃ANeBuȃXg[f[^[v
	int							FileCompCopyLength ;									// ݃ANeBuȃXg[f[^̃TEhobt@ւ̓]oCg
	int							FileUseFile ;											// C[Wł͂ȂfBXNȂǂ̕⏕Luɂt@CgpĂ邩ǂ
	int							TotalSample ;											// SXg[̃Tv

	DWORD						CompPlayWaveLength ;									// ĐIg`f[^̒
	DWORD						PrevCheckPlayPosition ;									// O`FbNĐʒu

	BYTE						StartSetupCompFlag ;									// ĐtO
	BYTE						EndWaitFlag ;											// I҂tO
	BYTE						LoopPositionValidFlag ;									// [vʒuLtO
	BYTE						AllPlayFlag ;											// ŜʂĈxłŌłĐtO
	DWORD						LoopAfterCompPlayWaveLength ;							// [v CompPlayWaveLength ɉZl
	
	DWORD						EndOffset ;												// IItZbg
	DWORD						EndStartOffset ;										// IJnItZbg
	DWORD						LoopPosition ;											// [vʒu(Đobt@̃AhX)

	HANDLELIST					StreamSoundList ;										// Xg[TEhXgp\
} ;

// m[}TEhvCpf[^
struct NORMALPLAYDATA
{
	int							WaveSize ;												// g`f[^̃TCY
	void						*WaveData ;												// g`f[^
	int							*WaveDataUseCount ;										// g`f[^QƐ
	int							BufferDuplicateFlag[ MAX_SOUNDBUFFER_NUM ] ;			// ꂽTEhobt@ǂ̃tO
	int							BackPlayBufferNo ;										// OɍĐTEhobt@̔ԍ(Đpobt@ꍇp)
} ;

// TEhf[^
struct SOUND
{
	HANDLEINFO					HandleInfo ;											// nhʏ

	HANDLELIST					_3DSoundList ;											// RcTEhXgp\
	int							Is3DSound ;												// RcTEhǂ( TRUE:RcTEh  FALSE:RcTEh )
	int							AddPlay3DSoundList ;									// Play3DSoundList XgɒǉĂ邩ǂ( TRUE:ǉĂ  FALSE:ǉĂȂ )
	HANDLELIST					Play3DSoundList ;										// Đ̂RcTEh̃Xgp\

	int							PlayFinishDeleteFlag ;									// TEh̍ĐI폜邩ǂ( TRUE:폜  FALSE:폜Ȃ )
	HANDLELIST					PlayFinishDeleteSoundList ;								// TEh̍ĐI폜TEh̃Xgp\

	int							NotInitSoundMemDelete ;									// InitSoundMem ō폜Ȃǂ̃tO( TRUE:InitSoundMemł͍폜Ȃ  FALSE:InitSoundMemō폜 )

//	char						FilePath[ 256 ] ;										// fBNg
//	char						SoundName[ 256 ] ;										// TEht@Cl[

	int							ValidBufferNum ;										// Lȃobt@̐
	int							BufferPlayStateBackupFlagValid[ MAX_SOUNDBUFFER_NUM ] ;	// BufferPlayStateBackupFlag Lǂ̃tO( TRUE:L  FALSE: )
	int							BufferPlayStateBackupFlag[ MAX_SOUNDBUFFER_NUM ] ;		// TEhobt@ꎞ~Ƃ̍ĐԃtO
	SOUNDBUFFER					Buffer[ MAX_SOUNDBUFFER_NUM ] ;							// TEhobt@
	WAVEFORMATEX				BufferFormat ;											// TEhobt@̃tH[}bg

	int							Type ;													// TEh̃^Cv
	int							PlayType ;												// Đ^Cv

	STREAMPLAYDATA				Stream ;												// Xg[TEhvCpf[^
	NORMALPLAYDATA				Normal ;												// m[}TEhvCpf[^

	int							PresetReverbParam ;										// RcTEhɐݒ肷vZbgo[up[^ԍ( DX_REVERB_PRESET_DEFAULT  )
	SOUND3D_REVERB_PARAM		ReverbParam ;											// RcTEhɐݒ肷郊o[up[^( PresetReverbParam  -1 ̍ۂɎgp )

	int							BaseVolume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;				// {{[( 1001fVxP 0 ` 10000 )( -1:ftHg )
	int							BaseVolume8bit[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;			// {{[( 0 ` 255 )( -1:ftHg )
	int							BasePan ;												// {p( -1:ftHg )
	int							BaseFrequency ;											// {Đg( -1:ftHg )
	VECTOR						Base3DPosition ;										// {Đʒu
	float						Base3DRadius ;											// {鋗
	VECTOR						Base3DVelocity ;										// {̑x
	int							PitchRateEnable ;										// sb`[gLǂ( TRUE:L  FALSE: )
	float						PitchRate ;												// sb`[g

	BYTE						ValidNextPlayVolume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;	// NextPlayVolume Lǂ( 1:L 0: )
	BYTE						ValidNextPlayPan ;										// NextPlayPan Lǂ( 1:L 0: )
	BYTE						ValidNextPlayFrequency ;								// NextPlayFrequency Lǂ( 1:L 0: )
	BYTE						ValidNextPlay3DPosition ;								// NextPlay3DPosition Lǂ( 1:L 0: )
	BYTE						ValidNextPlay3DRadius ;									// NextPlay3DRadius Lǂ( 1:L 0: )
	BYTE						ValidNextPlay3DVelocity ;								// NextPlay3DVelocity Lǂ( 1:L 0: )
	int							NextPlayVolume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;			// ɖ炷̃{[
	int							NextPlayPan ;											// ɖ炷̃p
	int							NextPlayFrequency ;										// ɖ炷̎g
	VECTOR						NextPlay3DPosition ;									// ɖ炷̈ʒu
	float						NextPlay3DRadius ;										// ɖ炷̕鋗
	VECTOR						NextPlay3DVelocity ;									// ɖ炷̈ړx
} ;

// \tgEGAňg`f[^̔g`f[^\
struct SOFTSOUND_WAVE
{
	int							BufferSampleNum ;										// obt@̃TCY( Tv )
	void *						Buffer ;												// f[^obt@
} ;

// \tgEGAňg`f[^̃vC[\
struct SOFTSOUND_PLAYER
{
	HANDLELIST					SoftSoundPlayerList ;									// \tgEGATEhvC[Xgp\

	int							StockSampleNum ;										// XgbNĂTv̐
	RINGBUF						StockSample ;											// TvXgbNpOobt@

	int							SoundBufferPlayStateBackupFlagValid ;					// SoundBufferPlayStateBackupFlag Lǂ̃tO( TRUE:L  FALSE: )
	int							SoundBufferPlayStateBackupFlag ;						// TEhobt@ꎞ~Ƃ̍ĐԃtO
	SOUNDBUFFER					SoundBuffer ;											// ĐpTEhobt@
	int							SoundBufferSize ;										// ĐpTEhobt@̃TCY( oCgP )
//	int							BackCheckPlayOffset ;									// OɃ`FbNĐʒu
	int							DataSetCompOffset ;										// f[^ZbgςłTEhobt@̈ʒu( -1:܂ZbgĂȂ )

	int							NoneDataSetCompOffset ;									// f[^̃ZbgJnTEhobt@̈ʒu( -1:܂ZbgĂȂ )
	int							NoneDataPlayCheckBackPlayOffset ;						// f[^̍ĐJno邽߂̑O`FbN̍Đʒu
	int							NoneDataPlayStartFlag ;									// f[^̍ĐJnĂ邩ǂtO( TRUE:Ă  FALSE:ĂȂ )

	int							MaxDataSetSize ;										// ĐʒuɐsăZbgőf[^TCYAoCgP( săZbgĂf[^̃TCỸTCYȏɂȂȂ悤ɂ )
	int							MinDataSetSize ;										// ĐʒuɐsăZbgŏf[^TCYAoCgP( săZbgĂf[^̃TCỸTCYȉɂȂȂ悤ɂ )

	int							IsPlayFlag ;											// Đǂ̃tO( TRUE:Đ   FALSE:~ )
} ;

// \tgEGAňg`f[^
struct SOFTSOUND
{
	HANDLEINFO					HandleInfo ;											// nhʏ

	int							IsPlayer ;												// vC[ǂ̃tO( TRUE:vC[  FALSE:TEhf[^ )
	WAVEFORMATEX				BufferFormat ;											// TEh̃tH[}bg

	union
	{
		SOFTSOUND_WAVE			Wave ;													// g`f[^
		SOFTSOUND_PLAYER		Player ;												// vC[
	} ;
} ;

#ifndef DX_NON_BEEP

// BEEPpTEhobt@̃f[^p\
struct SOUND_BEEP_BUFFERDATA
{
	SOUNDBUFFER					Buffer ;								// BEEPĐp̃TEhobt@
	DWORD						NextFillBufferPosition ;				// ̔g`f[^zuJnTvʒu
	int							NextUseOneCycleSampleBufferPosition ;	// ̔g`f[^zuŎgpg`P̃Tvobt@̃Tvʒu
	int							OneCycleSamples ;						// g`P̃Tv
	short						*OneCycleSampleBuffer ;					// g`P̃Tvi[Ăobt@
	int							OneCycleSampleBufferSize ;				// g`P̃Tvi[Ăobt@̃TCY
	int							VolumeUpRequest ;						// BEEPĐʃAbvNGXgtO
	int							PlayTime ;								// BEEPĐp̃TEhobt@̍ĐJn
	int							StopRequest ;							// BEEPĐ~NGXgtO
	int							StopTime ;								// BEEPĐp̃TEhobt@̍ĐԂ~ɂ
} ;

#endif // DX_NON_BEEP


// TEhVXepf[^\
struct SOUNDSYSTEMDATA
{
	int							InitializeFlag ;				// tO

	DWORD						OutputChannels ;				// o̓`l
	DWORD						OutputSmaplesPerSec ;			// o̓TvO[g

	int							_3DSoundOneMetreEnable ;		// _3DSoundOneMetre Lǂ( TRUE:L  FALSE: )
	float						_3DSoundOneMetre ;				// RcTEhp̂P[g
	_3DSOUNDINFO				ListenerInfo ;					// RcTEh̃Xi[̏
	VECTOR						ListenerSideDirection ;			// RcTEh̃Xi[̉

	HANDLELIST					_3DSoundListFirst ;				// RcTEhnhXg̐擪
	HANDLELIST					_3DSoundListLast ;				// RcTEhnhXg̏I[
	DX_CRITICAL_SECTION			_3DSoundListCriticalSection ;	// RcTEhXgANZXpNeBJZNV

	HANDLELIST					StreamSoundListFirst ;			// Xg[TEhnhXg̐擪
	HANDLELIST					StreamSoundListLast ;			// Xg[TEhnhXg̏I[
	DX_CRITICAL_SECTION			StreamSoundListCriticalSection ;// Xg[TEhnhXgANZXpNeBJZNV

	HANDLELIST					SoftSoundPlayerListFirst ;		// \tgEGAňg`f[^̃vC[̃nhXg̐擪
	HANDLELIST					SoftSoundPlayerListLast ;		// \tgEGAňg`f[^̃vC[̃nhXg̏I[

	HANDLELIST					PlayFinishDeleteSoundListFirst ; // ĐIɍ폜TEhnhXg̐擪
	HANDLELIST					PlayFinishDeleteSoundListLast ;	 // ĐIɍ폜TEhnhXg̏I[

	HANDLELIST					Play3DSoundListFirst ;			// ĐĂRcTEhXg̐擪
	HANDLELIST					Play3DSoundListLast ;			// ĐĂRcTEhXg̏I[
	DX_CRITICAL_SECTION			Play3DSoundListCriticalSection ;// ĐĂRcTEhXgANZXpNeBJZNV

	int							PlayWavSoundHandle ;			// PlayWav֐Ŗ炳ĂWAVEf[^̃nh

	int							Create3DSoundFlag ;				// 3DTEh쐬邩ǂ̃tO( TRUE:RcTEh쐬  FALSE:RcTEh쐬Ȃ )
	int							OldVolumeTypeFlag ;				// Ver3.10cȑỎʌvZgp邩ǂ̃tO( TRUE:ÂvZgp  FALSE:VvZgp )
	int							SoundMode ;						// Đ`

	int							MaxVolume ;						// ő剹

	int							EnableSoundCaptureFlag ;		// TEhLv`OƂ
#ifndef DX_NON_SAVEFUNCTION
	int							SoundCaptureFlag ;				// TEhLv`sĂŒǂ̃tO(TRUE:Œ FASLE:Ⴄ)
	int							SoundCaptureSample ;			// Lv`Tv̐(44.1KHzZ)
	DWORD_PTR					SoundCaptureFileHandle ;		// Lv`TEhۑĂt@C
#endif // DX_NON_SAVEFUNCTION

	int							CreateSoundDataType ;					// 쐬TEhf[^̃f[^^Cv
	int							CreateSoundPitchRateEnable ;			// 쐬TEhf[^̃sb`[gLǂ
	float						CreateSoundPitchRate ;					// 쐬TEhf[^̃sb`[g
	float						CreateSoundPitchRate_Cents ;			// 쐬TEhf[^̃sb`[g( ZgP )
	int							CreateSoundTimeStretchRateEnable ;		// 쐬TEhf[^̃^CXgb`[gLǂ
	float						CreateSoundTimeStretchRate ;			// 쐬TEhf[^̃^CXgb`[g
	int							CreateSoundLoopStartTimePosition ;		// 쐬TEhf[^̃[v͈͂̐[( ~b )
	int							CreateSoundLoopStartSamplePosition ;	// 쐬TEhf[^̃[v͈͂̐[( Tv )
	int							CreateSoundLoopEndTimePosition ;		// 쐬TEhf[^̃[v͈͂̏I[( ~b )
	int							CreateSoundLoopEndSamplePosition ;		// 쐬TEhf[^̃[v͈͂̏I[( Tv )
	int							CreateSoundIgnoreLoopAreaInfo ;			// 쐬TEhf[^Ń[v͈͏𖳎邩ǂ
	int							DisableReadSoundFunctionMask ;			// gpȂǂݍݏ̃}XN
#ifndef DX_NON_OGGVORBIS
	int							OggVorbisBitDepth ;				// nugp̃rbg[x(1:8bit 2:16bit)
	int							OggVorbisFromTheoraFile ;		// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif

#ifndef DX_NON_BEEP
	int							BeepFrequency ;									// ĐBEEP̎g
	int							BeepPlay ;										// BEEPĐǂ
	int							BeepSoundBufferUseIndex ;						// gpBEEPĐp̃TEhobt@
	SOUND_BEEP_BUFFERDATA		BeepSoundBuffer[ SOUND_BEEPSOUNDBUFFER_NUM ] ;	// BEEPp̃TEhobt@֘A
#endif

	short						SinTable[ SOUND_SINTABLE_DIV ] ;	// TCe[u

	void						*FFTVibrationWorkBuffer[ SOUND_FFT_BITCOUNT_MAX ] ;		// t[GϊpƗpobt@

	SOUNDSYSTEMDATA_PF			PF ;							// ˑ
} ;

// lhchf[^
struct MIDIHANDLEDATA
{
	HANDLEINFO					HandleInfo ;					// nhʃf[^

	int							PlayFlag ;						// ĐAtO
	int							PlayStartFlag ;					// ĐJnꂽAtO
	int							Volume ;						// 

	void						*DataImage ;					// lhcht@C̃f[^i[ĂAhX( DSOUND.SoundMode  DX_MIDIMODE_MCI ̎̂ݗL )
	int							DataSize ;						// lhcht@C̃f[^TCY( DSOUND.SoundMode  DX_MIDIMODE_MCI ̎̂ݗL )

	int							StartTime ;						// ĐJn

	MIDIHANDLEDATA_PF			PF ;							// ˑ
} ;

// lhchVXepf[^\
struct MIDISYSTEMDATA
{
	int							PlayFlag ;						// ttO
	int							PlayHandle ;					// t̃nh

	wchar_t						FileName[ FILEPATH_MAX ] ;		// t@Cl[

	int							LoopFlag ;						// [vtAtO

	int							StartTime ;						// ĐJn

	int							MemImagePlayFlag ;				// ̃C[WgpčĐĂ邩AtO( TRUE:C[W  FALSE:t@C )

	int							DefaultHandle ;					// W̍Đ֐ŎgpMIDInh
	int							DefaultHandleToSoundHandleFlag ;	// W̍Đ֐ōĐĂnh͉nhAtO

	MIDISYSTEMDATA_PF			PF ;							// ˑ
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// TEhVXef[^
extern SOUNDSYSTEMDATA SoundSysData ;

// lhchǗpf[^
extern MIDISYSTEMDATA MidiSystemData ;	

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		InitializeSoundSystem( void ) ;																			// TEhVXe
extern	int		TerminateSoundSystem( void ) ;																			// TEhVXěn

extern	int		RefreshStreamSoundPlayCompLength( int SoundHandle, int CurrentPosition = -1, int ASyncThread = FALSE ) ;	// TEhnh̍ĐԂXV
extern	int		ST_SoftSoundPlayerProcessAll( void ) ;																	// \tgEGAŐ䂷SẴTEhf[^vC[̒s

extern	int		StartSoundCapture( const wchar_t *SaveFilePath ) ;															// TEhLv`̊Jn
extern	int		SoundCaptureProcess( int CaptureSample ) ;																// TEhLv`̎I
extern	int		EndSoundCapture( void ) ;																				// TEhLv`̏I

extern	void	InitLoadSoundGParam( LOADSOUND_GPARAM *GParam ) ;														// LOADSOUND_GPARAM ̃f[^Zbg

extern	int		InitializeSoundHandle( HANDLEINFO *HandleInfo ) ;														// TEhnh̏
extern	int		TerminateSoundHandle( HANDLEINFO *HandleInfo ) ;														// TEhnȟn

extern	int		LoadSoundMemBase_UseGParam(              LOADSOUND_GPARAM *GParam, const wchar_t *WaveName, int BufferNum, int UnionHandle, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																		// LoadSoundMemBase ̃O[oϐɃANZXȂo[W
extern	int		LoadSoundMemByMemImageBase_UseGParam(    LOADSOUND_GPARAM *GParam, int CreateSoundHandle, int SoundHandle, const void *FileImageBuffer, int ImageSize, int BufferNum, int UnionHandle = -1, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;		// LoadSoundMemByMemImageBase ̃O[oϐɃANZXȂo[W
extern	int		LoadSoundMem2_UseGParam(                 LOADSOUND_GPARAM *GParam, const wchar_t *WaveName1 , const wchar_t *WaveName2, int ASyncLoadFlag = FALSE ) ;																									// LoadSoundMem2 ̃O[oϐɃANZXȂo[W
extern	int		LoadSoundMem2ByMemImage_UseGParam(       LOADSOUND_GPARAM *GParam, const void *FileImageBuffer1, int ImageSize1, const void *FileImageBuffer2, int ImageSize2, int ASyncLoadFlag = FALSE ) ;															// LoadSoundMem2ByMemImage ̃O[oϐɃANZXȂo[W

extern	int		AddStreamSoundMem_UseGParam(       LOADSOUND_GPARAM *GParam, STREAMDATA *Stream, int LoopNum,  int SoundHandle, int StreamDataType, int *CanStreamCloseFlag, int UnionHandle = -1, int ASyncThread = FALSE ) ;											// AddStreamSoundMem ̃O[oϐɃANZXȂo[W
extern	int		AddStreamSoundMemToFile_UseGParam( LOADSOUND_GPARAM *GParam, const wchar_t *WaveFile, int LoopNum,  int SoundHandle, int StreamDataType, int UnionHandle = -1, int ASyncThread = FALSE ) ;																// AddStreamSoundMemToFile ̃O[oϐɃANZXȂo[W
extern	int		AddStreamSoundMemToMem_UseGParam(  LOADSOUND_GPARAM *GParam, void *FileImageBuffer, int ImageSize, int LoopNum,  int SoundHandle, int StreamDataType, int UnionHandle = -1, int ASyncThread = FALSE ) ;													// AddStreamSoundMemToMem ̃O[oϐɃANZXȂo[W
extern	int		SetupStreamSoundMem_UseGParam(     int SoundHandle, int ASyncThread = FALSE ) ;																																											// SetupStreamSoundMem ̃O[oϐɃANZXȂo[W
extern	int		ProcessStreamSoundMem_UseGParam(   int SoundHandle, int ASyncThread = FALSE ) ;																																											// ProcessStreamSoundMem ̃O[oϐɃANZXȂo[W

extern	int		SetLoopAreaTimePosSoundMem_UseGParam(    int LoopStartTime,           int LoopEndTime,           int SoundHandle, int ASyncThread = FALSE ) ;																											// SetLoopAreaTimePosSoundMem ̃O[oϐɃANZXȂo[W
extern	int		SetLoopAreaSamplePosSoundMem_UseGParam(  int LoopStartSamplePosition, int LoopEndSamplePosition, int SoundHandle, int ASyncThread = FALSE ) ;																											// SetLoopAreaSamplePosSoundMem ̃O[oϐɃANZXȂo[W
extern	int		SetLoopTimePosSoundMem_UseGParam(        int LoopTime,                int SoundHandle, int ASyncThread = FALSE ) ;																																		// SetLoopTimePosSoundMem ̃O[oϐɃANZXȂo[W
extern	int		SetLoopSamplePosSoundMem_UseGParam(      int LoopSamplePosition,      int SoundHandle, int ASyncThread = FALSE ) ;																																		// SetLoopSamplePosSoundMem ̃O[oϐɃANZXȂo[W
extern	int		SetLoopStartTimePosSoundMem_UseGParam(   int LoopStartTime,           int SoundHandle, int ASyncThread = FALSE ) ;																																		// SetLoopStartTimePosSoundMem ̃O[oϐɃANZXȂo[W
extern	int		SetLoopStartSamplePosSoundMem_UseGParam( int LoopStartSamplePosition, int SoundHandle, int ASyncThread = FALSE ) ;																																		// SetLoopStartTimePosSoundMem ̃O[oϐɃANZXȂo[W

extern	int		GetSoundTotalSample_UseGParam( int SoundHandle, int ASyncThread = FALSE ) ;																																												// GetSoundTotalSample ̃O[oϐɃANZXȂo[W
extern	int		SetStreamSoundCurrentPosition_UseGParam( int Byte, int SoundHandle, int ASyncThread = FALSE ) ;																																							// SetStreamSoundCurrentPosition ̃O[oϐɃANZXȂo[W

extern	int		Refresh3DSoundParamAll() ;																				// Đׂ̂Ă̂RcTEh̃p[^XV

extern	int		ProcessPlayFinishDeleteSoundMemAll( void ) ;															// ĐITEhnh폜TEh̏s
extern	int		ProcessPlay3DSoundMemAll( void ) ;																		// RcTEhĐĂTEhnhɑ΂鏈s

extern	int		SetupSoftSoundHandle( int SoftSoundHandle, int IsPlayer, int Channels, int BitsPerSample, int SamplesPerSec, int IsFloatType, int SampleNum ) ;	// \tgTEhnhZbgAbv

extern	int		InitializeSoftSoundHandle( HANDLEINFO *HandleInfo ) ;													// \tgTEhnh̏
extern	int		TerminateSoftSoundHandle( HANDLEINFO *HandleInfo ) ;													// \tgTEhnȟn

extern	int		DeleteCancelCheckSoftSoundFunction( HANDLEINFO *HandleInfo ) ;											// \tgTEhnh폜邩ǂ`FbN֐
extern	int		DeleteCancelCheckSoftSoundPlayerFunction( HANDLEINFO *HandleInfo ) ;									// \tgTEhv[[nh폜邩ǂ`FbN֐

extern	int		LoadSoftSoundBase_UseGParam( LOADSOUND_GPARAM *GParam, const wchar_t *FileName, const void *FileImage, int FileImageSize, int ASyncLoadFlag = FALSE ) ;		// \tgEGAňg`f[^t@C܂̓ɓWJꂽt@CC[W쐬
extern	int		MakeSoftSoundBase_UseGParam( int IsPlayer, int Channels, int BitsPerSample, int SamplesPerSec, int SampleNum, int IsFloatType, int UseFormat_SoftSoundHandle = -1, int ASyncLoadFlag = FALSE ) ;	// \tgEGAŐ䂷TEhf[^nh̍쐬

extern	int		AddMusicData( void ) ;																					// Vlhchnh擾

extern	int		InitializeMidiHandle( HANDLEINFO *HandleInfo ) ;														// lhchnh֐
extern	int		TerminateMidiHandle( HANDLEINFO *HandleInfo ) ;															// lhchnȟns֐

extern	int		LoadMusicMemByMemImage_UseGParam( void *FileImage, int FileImageSize, int ASyncLoadFlag = FALSE ) ;		// LoadMusicMemByMemImage ̃O[oϐɃANZXȂo[W
extern	int		LoadMusicMem_UseGParam( const wchar_t *FileName, int ASyncLoadFlag = FALSE ) ;							// LoadMusicMem ̃O[oϐɃANZXȂo[W
extern	int		LoadMusicMemByResource_UseGParam( const wchar_t *ResourceName, const wchar_t *ResourceType, int ASyncLoadFlag = FALSE ) ;	// LoadMusicMemByResource ̃O[oϐɃANZXȂo[W
extern	int		LoadMusicMemByMemImage_Static( int MusicHandle, const void *FileImage, int FileImageSize, int ASyncThread ) ;		// LoadMusicMemByMemImage ̎֐

extern	int		PauseSoundMemAll( int PauseFlag ) ;																		// SẲ̈ꎞ~ԂύX
extern	int		PauseSoftSoundAll( int PauseFlag ) ;																	// SẴ\tgEGATEḧꎞ~ԂύX

extern	int		CopySoftSound( int SrcSoftSoundHandle, int DestSoftSoundHandle ) ;										// TEhf[^ʂ̃TEhf[^ɃRs[
extern	int		ConvertIntToFloatSoftSound( int SrcSoftSoundHandle, int DestSoftSoundHandle ) ;							// int^̃TEhf[^ float^̃TEhf[^ZbgAbv
extern	int		ConvertFloatToIntSoftSound( int SrcSoftSoundHandle, int DestSoftSoundHandle ) ;							// float^̃TEhf[^ int^̃TEhf[^ZbgAbv





// wchar_tŊ֐
extern	int		AddStreamSoundMemToFile_WCHAR_T(	const wchar_t *WaveFile, int LoopNum,  int SoundHandle, int StreamDataType, int UnionHandle = -1 ) ;
extern	int		LoadSoundMem2_WCHAR_T(				const wchar_t *FileName1, const wchar_t *FileName2 ) ;

extern	int		LoadBGM_WCHAR_T(					const wchar_t *FileName ) ;

extern	int		LoadSoundMemBase_WCHAR_T(			const wchar_t *FileName, int BufferNum,      int UnionHandle = -1 ) ;
extern	int		LoadSoundMem_WCHAR_T(				const wchar_t *FileName, int BufferNum = 3 , int UnionHandle = -1 ) ;
extern	int		LoadSoundMemToBufNumSitei_WCHAR_T(	const wchar_t *FileName, int BufferNum ) ;
extern	int		LoadSoundMemByResource_WCHAR_T(		const wchar_t *ResourceName, const wchar_t *ResourceType, int BufferNum = 1 ) ;

extern	int		PlaySoundFile_WCHAR_T(				const wchar_t *FileName, int PlayType ) ;
extern	int		PlaySound_WCHAR_T(					const wchar_t *FileName, int PlayType ) ;

extern	int		LoadSoftSound_WCHAR_T(				const wchar_t *FileName ) ;

#ifndef DX_NON_SAVEFUNCTION
extern	int		SaveSoftSound_WCHAR_T(				int SoftSoundHandle, const wchar_t *FileName ) ;
#endif // DX_NON_SAVEFUNCTION

extern	int		LoadMusicMem_WCHAR_T(				const wchar_t *FileName ) ;
extern	int		LoadMusicMemByResource_WCHAR_T(		const wchar_t *ResourceName, const wchar_t *ResourceType ) ;

extern	int		PlayMusic_WCHAR_T(					const wchar_t *FileName, int PlayType ) ;

extern	int		PlayMusicByResource_WCHAR_T(		const wchar_t *ResourceName, const wchar_t *ResourceType, int PlayType ) ;

extern	int		GetMP3TagInfo_WCHAR_T(              const wchar_t *FileName, TCHAR *TitleBuffer, size_t TitleBufferBytes, TCHAR *ArtistBuffer, size_t ArtistBufferBytes, TCHAR *AlbumBuffer, size_t AlbumBufferBytes, TCHAR *YearBuffer, size_t YearBufferBytes, TCHAR *CommentBuffer, size_t CommentBufferBytes, TCHAR *TrackBuffer, size_t TrackBufferBytes, TCHAR *GenreBuffer, size_t GenreBufferBytes, int *PictureGrHandle ) ;




//TEhobt@p
extern	int		SoundBuffer_Initialize(          SOUNDBUFFER *Buffer, DWORD Bytes, WAVEFORMATEX *Format, SOUNDBUFFER *Src, int UseGetCurrentPosition, int IsStream, int Is3DSound ) ;
extern	int		SoundBuffer_Duplicate(           SOUNDBUFFER *Buffer, SOUNDBUFFER *Src, int Is3DSound ) ;
extern	int		SoundBuffer_Terminate(           SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_CheckEnable(         SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_Play(                SOUNDBUFFER *Buffer, int Loop ) ;
extern	int		SoundBuffer_Stop(                SOUNDBUFFER *Buffer, int EffectStop = FALSE ) ;
extern	int		SoundBuffer_CheckPlay(           SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_Lock(                SOUNDBUFFER *Buffer, DWORD  WritePos, DWORD WriteSize, void **LockPos1, DWORD *LockSize1, void **LockPos2, DWORD *LockSize2 ) ;
extern	int		SoundBuffer_Unlock(              SOUNDBUFFER *Buffer, void  *LockPos1, DWORD LockSize1, void  *LockPos2, DWORD LockSize2 ) ;
extern	int		SoundBuffer_SetFrequency(        SOUNDBUFFER *Buffer, DWORD Frequency ) ;
extern	int		SoundBuffer_GetFrequency(        SOUNDBUFFER *Buffer, DWORD * Frequency ) ;
extern	int		SoundBuffer_SetPan(              SOUNDBUFFER *Buffer, LONG Pan ) ;
extern	int		SoundBuffer_GetPan(              SOUNDBUFFER *Buffer, LPLONG Pan ) ;
extern	int		SoundBuffer_RefreshVolume(       SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_SetVolumeAll(        SOUNDBUFFER *Buffer, LONG Volume ) ;
extern	int		SoundBuffer_SetVolume(           SOUNDBUFFER *Buffer, int Channel, LONG Volume ) ;
extern	int		SoundBuffer_GetVolume(           SOUNDBUFFER *Buffer, int Channel, LPLONG Volume ) ;
extern	int		SoundBuffer_GetCurrentPosition(  SOUNDBUFFER *Buffer, DWORD * PlayPos, DWORD * WritePos ) ;
extern	int		SoundBuffer_SetCurrentPosition(  SOUNDBUFFER *Buffer, DWORD NewPos ) ;
extern	int		SoundBuffer_CycleProcess(        SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_FrameProcess(        SOUNDBUFFER *Buffer, int Sample, short *DestBuf ) ;
extern	int		SoundBuffer_Set3DPosition(       SOUNDBUFFER *Buffer, VECTOR *Position ) ;
extern	int		SoundBuffer_Set3DRadius(         SOUNDBUFFER *Buffer, float Radius ) ;
extern	int		SoundBuffer_Set3DInnerRadius(    SOUNDBUFFER *Buffer, float Radius ) ;
extern	int		SoundBuffer_Set3DVelocity(       SOUNDBUFFER *Buffer, VECTOR *Velocity ) ;
extern	int		SoundBuffer_Set3DFrontPosition(  SOUNDBUFFER *Buffer, VECTOR *FrontPosition, VECTOR *UpVector ) ;
extern	int		SoundBuffer_Set3DConeAngle(      SOUNDBUFFER *Buffer, float InnerAngle, float OuterAngle ) ;
extern	int		SoundBuffer_Set3DConeVolume(     SOUNDBUFFER *Buffer, float InnerAngleVolume, float OuterAngleVolume ) ;
extern	int		SoundBuffer_Refresh3DSoundParam( SOUNDBUFFER *Buffer, int AlwaysFlag = FALSE ) ;
extern	int		SoundBuffer_SetReverbParam(      SOUNDBUFFER *Buffer, SOUND3D_REVERB_PARAM *Param ) ;
extern	int		SoundBuffer_SetPresetReverbParam( SOUNDBUFFER *Buffer, int PresetNo ) ;


// g`f[^p
extern	WAVEDATA *	AllocWaveData( int Size, int UseDoubleSizeBuffer = FALSE ) ;
extern	int			ReleaseWaveData( WAVEDATA *Data ) ;
extern	WAVEDATA *	DuplicateWaveData( WAVEDATA *Data ) ;







// ˑ֐
extern	int		InitializeSoundSystem_PF_Timing0( void ) ;											// TEhVXe֐̊ˑs֐( sӏʂO )
extern	int		InitializeSoundSystem_PF_Timing1( void ) ;											// TEhVXe֐̊ˑs֐( sӏʂP )

extern	int		TerminateSoundSystem_PF_Timing0( void ) ;											// TEhVXěn֐̊ˑs֐( sӏʂO )
extern	int		TerminateSoundSystem_PF_Timing1( void ) ;											// TEhVXěn֐̊ˑs֐( sӏʂP )

extern	int		CheckSoundSystem_Initialize_PF( void ) ;											// TEhVXȅ`FbN̊ˑs֐( TRUE:Ă  FALSE:ĂȂ )

extern	int		TerminateMidiHandle_PF( MIDIHANDLEDATA *MusicData ) ;								// lhchnȟns֐̊ˑ

extern	int		Get3DPresetReverbParamSoundMem_PF( SOUND3D_REVERB_PARAM *ParamBuffer, int PresetNo /* DX_REVERB_PRESET_DEFAULT  */ ) ;		// vZbĝRcTEhp̃o[up[^擾鏈̊ˑs֐
extern	int		Set3DSoundListenerPosAndFrontPosAndUpVec_PF( VECTOR Position, VECTOR FrontPosition, VECTOR UpVector ) ;							// RcTEh̃Xi[̈ʒuƃXi[̑OʒuƃXi[̏ʒuݒ肷鏈̊ˑs֐
extern	int		Set3DSoundListenerVelocity_PF( VECTOR Velocity ) ;																				// RcTEh̃Xi[̈ړxݒ肷鏈̊ˑs֐
extern	int		Set3DSoundListenerConeAngle_PF( float InnerAngle, float OuterAngle ) ;															// RcTEh̃Xi[̉px͈͂ݒ肷鏈̊ˑs֐
extern	int		Set3DSoundListenerConeVolume_PF( float InnerAngleVolume, float OuterAngleVolume ) ;												// RcTEh̃Xi[̉px͈͂̉ʔ{ݒ肷鏈̊ˑs֐

extern	int		LoadMusicMemByMemImage_Static_PF( MIDIHANDLEDATA *MusicData, int ASyncThread ) ;												// LoadMusicMemByMemImage ̎֐̊ˑs֐
extern	int		PlayMusicMem_PF( MIDIHANDLEDATA *MusicData, int PlayType ) ;																	// ǂݍ񂾂lhchf[^̉tJn鏈̊ˑs֐
extern	int		StopMusicMem_PF( MIDIHANDLEDATA *MusicData ) ;																					// lhchf[^̉t~鏈̊ˑs
extern	int		CheckMusicMem_PF( MIDIHANDLEDATA *MusicData ) ;																					// lhchf[^tǂ擾( TRUE:t  FALSE:~ )̊ˑs֐
extern	int		ProcessMusicMem_PF( MIDIHANDLEDATA *MusicData ) ;																				// lhchf[^̎I̊ˑs֐
extern	int		GetMusicMemPosition_PF( MIDIHANDLEDATA *MusicData ) ;																			// lhchf[^݂̌̍Đʒu擾鏈̊ˑs֐
extern	int		SetVolumeMusic_PF( int Volume ) ;																								// lhch̍ĐʂZbg鏈̊ˑs֐
extern	int		GetMusicPosition_PF( void ) ;																									// lhcȟ݂̍Đʒu擾鏈̊ˑs֐




extern	int		SoundBuffer_Initialize_Timing0_PF(	SOUNDBUFFER *Buffer, DWORD Bytes, WAVEFORMATEX *Format, SOUNDBUFFER *Src, int Is3DSound ) ;
extern	int		SoundBuffer_Initialize_Timing1_PF(	SOUNDBUFFER *Buffer, SOUNDBUFFER *Src, int Is3DSound ) ;
extern	int		SoundBuffer_Terminate_PF(           SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_CheckEnable_PF(         SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_Play_PF(                SOUNDBUFFER *Buffer, int Loop ) ;
extern	int		SoundBuffer_Stop_PF(				SOUNDBUFFER *Buffer, int EffectStop ) ;
extern	int		SoundBuffer_CheckPlay_PF(           SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_Lock_PF(                SOUNDBUFFER *Buffer, DWORD WritePos , DWORD WriteSize, void **LockPos1, DWORD *LockSize1, void **LockPos2, DWORD *LockSize2 ) ;
extern	int		SoundBuffer_Unlock_PF(              SOUNDBUFFER *Buffer, void *LockPos1, DWORD LockSize1, void *LockPos2, DWORD LockSize2 ) ;
extern	int		SoundBuffer_SetFrequency_PF(        SOUNDBUFFER *Buffer, DWORD Frequency ) ;
extern	int		SoundBuffer_GetFrequency_PF(        SOUNDBUFFER *Buffer, DWORD * Frequency ) ;
extern	int		SoundBuffer_RefreshVolume_PF(		SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_GetCurrentPosition_PF(	SOUNDBUFFER *Buffer, DWORD * PlayPos, DWORD * WritePos ) ;
extern	int		SoundBuffer_SetCurrentPosition_PF(	SOUNDBUFFER *Buffer, DWORD NewPos ) ;
extern	int		SoundBuffer_CycleProcess_PF(		SOUNDBUFFER *Buffer ) ;
extern	int		SoundBuffer_Set3DPosition_PF(		SOUNDBUFFER *Buffer, VECTOR *Position ) ;
extern	int		SoundBuffer_Set3DRadius_PF(			SOUNDBUFFER *Buffer, float Radius ) ;
extern	int		SoundBuffer_Set3DInnerRadius_PF(	SOUNDBUFFER *Buffer, float Radius ) ;
extern	int		SoundBuffer_Set3DVelocity_PF(		SOUNDBUFFER *Buffer, VECTOR *Velocity ) ;
extern	int		SoundBuffer_Set3DFrontPosition_PF(	SOUNDBUFFER *Buffer, VECTOR *FrontPosition, VECTOR *UpVector ) ;
extern	int		SoundBuffer_Set3DConeAngle_PF(		SOUNDBUFFER *Buffer, float InnerAngle, float OuterAngle ) ;
extern	int		SoundBuffer_Set3DConeVolume_PF(		SOUNDBUFFER *Buffer, float InnerAngleVolume, float OuterAngleVolume ) ;
extern	int		SoundBuffer_Refresh3DSoundParam_PF(	SOUNDBUFFER *Buffer, int AlwaysFlag ) ;
extern	int		SoundBuffer_SetReverbParam_PF(		SOUNDBUFFER *Buffer, SOUND3D_REVERB_PARAM *Param ) ;
extern	int		SoundBuffer_SetPresetReverbParam_PF( SOUNDBUFFER *Buffer, int PresetNo ) ;








#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_SOUND

#endif // DX_SOUND_H
